--------------------------------------------------------------------------------
-- From Deriving to Regular
--------------------------------------------------------------------------------

{-# LANGUAGE DataKinds              #-}
{-# LANGUAGE PolyKinds              #-}
{-# LANGUAGE TypeFamilies           #-}
{-# LANGUAGE TypeOperators          #-}
{-# LANGUAGE GADTs                  #-}
{-# LANGUAGE FlexibleInstances      #-}
{-# LANGUAGE FlexibleContexts       #-}
{-# LANGUAGE UndecidableInstances   #-}
{-# LANGUAGE MultiParamTypeClasses  #-}

module Test.D2R where


import qualified Test.Deriving   as D
import qualified Library.Regular as R
import Conversion.D2R

--------------------------------------------------------------------------------
-- Tests
--------------------------------------------------------------------------------

-- No empty instances are necessary for this test because we didn't put R.size
-- inside a type class
td2r1, td2r2 :: Int
td2r1 = R.size "abc"
td2r2 = R.size (D.RTree (0::Int) [D.RTree 1 []]) -- returns 0, as expected
